import { IAppToolkit } from '../../../app-toolkit/app-toolkit.interface';
import { AppTokenTemplatePositionFetcher } from '../../../position/template/app-token.template.position-fetcher';
import { GetUnderlyingTokensParams, GetAddressesParams, GetDataPropsParams, GetPriceParams, DefaultAppTokenDataProps } from '../../../position/template/app-token.template.types';
import { TenderizeContractFactory, TenderToken } from '../contracts';
import { TenderizeTokenDefinition } from './tenderize-token-definition';
import { TenderizeTokenDefinitionsResolver } from './tenderize.token-definition-resolver';
export declare abstract class SwapTokenFetcher extends AppTokenTemplatePositionFetcher<TenderToken, DefaultAppTokenDataProps, TenderizeTokenDefinition> {
    protected readonly appToolkit: IAppToolkit;
    private readonly tokenDefinitionsResolver;
    protected readonly contractFactory: TenderizeContractFactory;
    constructor(appToolkit: IAppToolkit, tokenDefinitionsResolver: TenderizeTokenDefinitionsResolver, contractFactory: TenderizeContractFactory);
    getContract(address: string): TenderToken;
    getDefinitions(): Promise<TenderizeTokenDefinition[]>;
    getAddresses({ definitions }: GetAddressesParams<TenderizeTokenDefinition>): Promise<string[]>;
    getUnderlyingTokenDefinitions({ definition, }: GetUnderlyingTokensParams<TenderToken, TenderizeTokenDefinition>): Promise<{
        address: string;
        network: import("../../../types").Network;
    }[]>;
    getPricePerShare(): Promise<number[]>;
    getPrice({ appToken, }: GetPriceParams<TenderToken, DefaultAppTokenDataProps, TenderizeTokenDefinition>): Promise<number>;
    getLiquidity({ appToken }: GetDataPropsParams<TenderToken>): Promise<number>;
    getReserves({ appToken }: GetDataPropsParams<TenderToken>): Promise<number[]>;
    getApy(): Promise<number>;
}
